=== debian/changelog ===
csound (1:6.07.0~dfsg-2) unstable; urgency=medium

  * pffft: Only use simd instructions on amd64

 -- Felipe Sateler <fsateler@debian.org>  Sun, 03 Jul 2016 21:23:24 -0400

csound (1:6.07.0~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 6.07.0~dfsg
    - Add html examples to Files-Excluded
    - Remove debian-specific .gitignore
  * Update patches for new upstream version.
    Dropped:
    - Disable-html-timestamps.patch
    - Do-not-pass-a-null-pointer-to-strdup.-Fixes-466.patch
    - Introduce-CS_PACKAGE_DATE-macro.patch
    Dropped because better fix applied upstream:
    - debian-specific/apidoc-dotpath.patch
    - debian-specific/avoid-nonfree-scansyn-plugin.diff
    Refreshed:
    - debian-specific/lua-link.diff
  * Drop cdbs upstream tarball handling in favor of using uscan
  * Update upstream urls to github
  * Add libsamplerate build-depend for src_conv
  * Update copyright check usage
  * Fix USE_ATOMIC_BUILTIN typo
  * Drop BUILD_NEW_PARSER option, no longer exists
  * Specify python version
  * Install icsound and ctcsound python modules
  * Add build-depends on dh-python
  * fail-missing: do not skip python files
  * Add new symbols introduced in the new upstream version
  * Disable finite-math-only gcc flag (introduces weird symbols in public lib)

 -- Felipe Sateler <fsateler@debian.org>  Sun, 03 Jul 2016 14:45:28 -0400
